#include <stdio.h>
#define InFile "secvop.in"
#define OutFile "secvop.out"
#define Abs(x) ((x)>0?(x):(-(x)))
struct Interval {long  X, Y;};
struct Nod
       {
       Interval Value;
       Nod * Next;
       Nod * Prev;
       };
typedef Nod* PList;
PList P;
long N, K;
FILE * fin;
FILE * fout;

void Part(PList & P, long X)
//partitioneaza intervalul memorat in nodul indicat de P in doua intervale,
//pozitia de splitare fiind X
{
PList Tmp=new Nod;
if (P->Value.X<P->Value.Y)
   Tmp->Value.X=X+1; //interval crescator
   else Tmp->Value.X=X-1; //interval descrescator
Tmp->Value.Y=P->Value.Y;
P->Value.Y=X;
Tmp->Next=P->Next; Tmp->Prev=P;
if (P->Next!=NULL)  P->Next->Prev=Tmp;
P->Next=Tmp;
}

void Swap(long & X, long & Y)
{long Tmp;
 Tmp=X; X=Y; Y=Tmp; }

long GetItem(PList & P, long X)
//identifica in lista P elementul aflat pe pozitia X
{
long K=0;
while (K+Abs(P->Value.X-P->Value.Y)+1<X)
      {
      K=K+Abs(P->Value.X-P->Value.Y)+1;
      P=P->Next;
     }
return X-K;
}

void Inverse(PList & P, long X, long Y)
/*inverseaza intervalul de la pozitia X la pozitia Y:
 -determina elementul situat pe pozitia X
 -partitioneaza intervalul in care se afla elementul situat pe pozitia X in doua intervale
 -determina elementul situat pe pozitia Y
 -partitioneaza intervalul in care se afla elementul situat pe pozitia Y in doua intervale
 -parcurge nodurile din lista situate intre pozitiile X si Y si inverseaza intervalele corespunzatoare
*/
{
PList Q1=P;
long M;
long K=GetItem(Q1, X);
if (K > 1)
   {
   if (Q1->Value.X < Q1->Value.Y)  M=Q1->Value.X+K-2;
      else M=Q1->Value.X-K+2;
   Part(Q1, M);
   Q1=Q1->Next;
   };
PList Q2=P;
K=GetItem(Q2, Y);
if (K < Abs(Q2->Value.X-Q2->Value.Y)+1)
   {
   if (Q2->Value.X < Q2->Value.Y)  M=Q2->Value.X+K-1;
      else M=Q2->Value.X-K+1;
   Part(Q2, M);
   };
while (Q1->Prev!=Q2)
      {
      Swap(Q1->Value.X, Q2->Value.Y);
      if (Q1!=Q2)  Swap(Q1->Value.Y, Q2->Value.X); else break;
      Q1=Q1->Next;
      Q2=Q2->Prev;
      }
}

long long GetIntervalPart(Interval P, long K)
{
long long S;
if (P.X < P.Y)  S=(long long)P.X*K; else S=(long long)(P.X-K+1)*K;
return S+(long long)K*(K-1)/2;
}

long long GetIntervalSum(Interval P)
//calculeaza suma elementelor din intervalul P
{long long S, N;
N=Abs(P.X-P.Y)+1;
if (P.X < P.Y)  S=N*P.X; else S=N*P.Y;
 return S+N*(N-1)/2;
}

long long Sum(PList & P,long X, long Y)
{
//returneaza suma elementelor de la poz X la poz Y
PList Q1, Q2, Q;
long  K1, K2;
long long S1, S2, S;
Q1=P;
K1=GetItem(Q1, X); //determina elementul situat pe pozitia X
Q2=P;
K2=GetItem(Q2, Y); //determina elementul situat pe pozitia Y
S1=GetIntervalSum(Q1->Value) - GetIntervalPart(Q1->Value, K1-1);
S2=GetIntervalPart(Q2->Value, K2);
if (Q1 == Q2)  //X si Y sunt in acelasi interval
   S=S1+S2-GetIntervalSum(Q1->Value);
   else
   {
   S=S1+S2;
   Q=Q1->Next;  //parcurg intervalele de la Q1 la Q2 si adun sumele elementelor
   while (Q!=Q2)
         {
          S=S+GetIntervalSum(Q->Value);
          Q=Q->Next;
         }
   }
return S;
}


void Rezolvare()
{
long X, Y, i;
char C[5];
//initializam lista de intervale cu intervalul [1,N]
P=new Nod;
P->Next=NULL; P->Prev=NULL;
P->Value.X=1;P->Value.Y=N;
for (i=1; i<=K; i++)
    {
    fscanf(fin,"%s %ld %ld", C, &X, &Y);
    if (C[0] == 'I')  Inverse(P, X, Y);
       else
       if (C[0] == 'S') fprintf(fout,"%lld\n",Sum(P, X, Y));
     }
}

int main()
{fin=fopen(InFile,"r");
 fout=fopen(OutFile,"w");
 fscanf(fin,"%ld %ld", &N, &K);
 Rezolvare();
 fclose(fout);
 return 0;
}
